zoukankan      html  css  js  c++  java
  • LightOJ 1138

    Description:

    You task is to find minimal natural number N, so that N! contains exactly Q zeroes on the trail in decimal notation. As you know N! = 1*2*...*N. For example, 5! = 120, 120 contains one zero on the trail.

    Input:

    Input starts with an integer T (≤ 10000), denoting the number of test cases.

    Each case contains an integer Q (1 ≤ Q ≤ 108) in a line.

    Output:

    For each case, print the case number and N. If no solution is found then print 'impossible'.

    Sample Input:

    3

    1

    2

    5

    Sample Output:

    Case 1: 5

    Case 2: 10

    Case 3: impossible

    题意:找阶乘尾0的个数是q的数,输出最小的那个。

    #include<stdio.h>
    #include<string.h>
    #include<algorithm>
    using namespace std;
    
    int Solve(int n) ///计算n的阶乘的尾0个数
    {
        int sum = 0;
    
        while (n)
        {
            sum += n/5;
            n /= 5;
        }
    
        return sum;
    }
    
    int main ()
    {
        int T, q, k = 0, i, mid, j, x, y;
    
        scanf("%d", &T);
    
        while (T--)
        {
            scanf("%d", &q);
    
            k++;
            x = -1;
    
            i = 1; j = 1e9;
    
            while (i <= j) ///用二分搜索枚举1e9以内的数的阶乘尾数0的个数,保存在y中
            {
                mid = (i+j)/2;
    
                y = Solve(mid);
    
                if (y >= q) ///如果找到的尾数0的个数比q大,继续查找左边区间
                {
                    j = mid-1;
                    if (y == q) ///如果找到的尾数0的个数等于q,保存这个值终止循环
                    {
                        x = mid;
                        break;
                    }
                }
                else i = mid+1; ///如果找到的尾数0的个数比q小,继续查找右边区间
            }
         
            if (x % 5 != 0) x = x-x%5; ///因为题目要求找到最小的x  所以要对x向下取整
                                      ///(eg: q==3 时  二分查找到的x可能是15,16,17,18,19)
            if (x == 0) x = -1; ///可能找不到某个数的阶乘有q个0
            if (x == -1) printf("Case %d: impossible
    ", k);
            else printf("Case %d: %d
    ", k, x);
        }
    
        return 0;
    }
  • 相关阅读:
    QDUOJ LC的课后辅导 单调递增栈
    蓝桥杯 时间问题
    区间sum 和为k的连续区间-前缀和
    康托展开-全排列的编码与解码
    康托展开-全排列应用
    背包之01背包、完全背包、多重背包详解
    HDU
    辗转相除求最大公约数与最小公倍数
    快速幂(反复平方法)
    HDU
  • 原文地址:https://www.cnblogs.com/syhandll/p/4746196.html
Copyright © 2011-2022 走看看